package test.rewolucja.resources.reader.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.MissingResourceException;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;


public class TempResourceDescriptionReader {

	public static final String FIRST_LAYER = "firstLayer";
	public static final String SECOND_LAYER  = "secondLayer";
	public static final String THIRD_LAYER  = "thirdLayer";
	public static final String FOURTH_LAYER  = "fourthLayer";
	public static final String FIFTH_LAYER  = "fifthLayer";
	public static final String SIXTH_LAYER  = "sixthLayer";

	public static final String GRIDS = "grids";
	public static final String DATA_CENTERS = "dataCenters";
	public static final String RACKS = "racks";
	public static final String NODES = "nodes";
	public static final String CPUS = "cpus";
	public static final String CORES = "cores";

	/*public static final String COMPUTING_GRID = "computingGrid";
	public static final String COMPUTING_RESOURCE = "computingResource";
	public static final String RACK = "rack";
	public static final String COMPUTING_NODE = "computingNode";
	public static final String CPU = "cpu";
	public static final String CORE = "core";*/
	
	public ArrayList<String> resources = null;
	public Map<String, String> res_amount;
	public Map<String, String> layer_management;
	
	public String grids = null;
	public String dataCenters = null;
	public String racks = null;
	public static String nodes = null;
	public String cpus= null;
	public String cores = null;
	
	public static final String MODEL_A = "modelA";
	public static final String MODEL_B = "modelB";
	public static final String MODEL_C = "modelC";
	
	public static String modelA = null;
	public static String modelB = null;
	public static String modelC = null;

	

	protected TempResourceDescriptionReader() {

		resources = new ArrayList<String>();
		res_amount = new HashMap<String, String>();
		layer_management = new HashMap<String, String>();
	}


	public static TempResourceDescriptionReader getConfiguration(String resBundleFileName) {

		TempResourceDescriptionReader co = new TempResourceDescriptionReader();
		File resBundleFile = new File(resBundleFileName);
		ResourceBundle bundle = null;
		try {
			bundle = new PropertyResourceBundle(new FileInputStream(resBundleFile));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return null;
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
		
		/********LAYERS*******/
		
		try {
			co.resources.add (bundle
					.getString(FIRST_LAYER));
		} catch(MissingResourceException e){
			//co.firstLayer = null;
		}
		
		try {
			co.resources.add(bundle
					.getString(SECOND_LAYER));
		} catch(MissingResourceException e){
			//co.secondLayer = null;
		}
		
		try {
			co.resources.add(bundle
					.getString(THIRD_LAYER));
		} catch(MissingResourceException e){
			//co.thirdLayer = null;
		}
		
		try {
			co.resources.add(bundle
					.getString(FOURTH_LAYER));
		} catch(MissingResourceException e){
			//co.fourthLayer = null;
		}
		
		try {
			co.resources.add(bundle
					.getString(FIFTH_LAYER));
		} catch(MissingResourceException e){
			//co.fifthLayer = null;
		}
		
		try {
			co.resources.add(bundle
					.getString(SIXTH_LAYER));
		} catch(MissingResourceException e){
			//co.sixthLayer = null;
		}
		
		/********CHARACTERISTIC*******/
		
		try {
			co.grids = bundle
					.getString(GRIDS);
			co.res_amount.put("COMPUTING_GRID",co.grids);
		} catch(MissingResourceException e){
			co.grids = null;
		}
		
		try {
			co.dataCenters = bundle
					.getString(DATA_CENTERS);
			co.res_amount.put("DATA_CENTER", co.dataCenters);
		} catch(MissingResourceException e){
			co.dataCenters = null;
		}
	
		try {
			co.racks = bundle
					.getString(RACKS);
			co.res_amount.put("RACK", co.racks);
		} catch(MissingResourceException e){
			co.racks = null;
		}
		
		try {
			co.nodes = bundle
					.getString(NODES);
			co.res_amount.put("COMPUTING_NODE", co.nodes);
		} catch(MissingResourceException e){
			co.nodes = null;
		}

		try {
			co.cpus = bundle
					.getString(CPUS);
			co.res_amount.put("CPU", co.cpus);
		} catch(MissingResourceException e){
			co.cpus = null;
		}

		try {
			co.cores = bundle
					.getString(CORES);
			co.res_amount.put("CORE", co.cores);
		} catch(MissingResourceException e){
			co.cores = null;
		}
		
		/********MANAGEMENT*******/
		
		/*try {
			co.layer_management.put("COMPUTING_GRID",bundle
					.getString(COMPUTING_GRID));
		} catch(MissingResourceException e){
			//co.grids = null;
		}
		
		try {
			co.layer_management.put("COMPUTING_RESOURCE", bundle
					.getString(COMPUTING_RESOURCE));
		} catch(MissingResourceException e){
			//co.dataCenters = null;
		}
	
		try {
			co.layer_management.put("RACK", bundle
					.getString(RACK));
		} catch(MissingResourceException e){
			//co.racks = null;
		}
		
		try {
			co.layer_management.put("COMPUTING_NODE", bundle
					.getString(COMPUTING_NODE));
		} catch(MissingResourceException e){
			//co.nodes = null;
		}

		try {
			co.layer_management.put("CPU", bundle
					.getString(CPU));
		} catch(MissingResourceException e){
			//co.cpus = null;
		}*

		try {
			co.layer_management.put("CORE", bundle
					.getString(CORE));
		} catch(MissingResourceException e){
			//co.cores = null;
		}
		
		/********MODELS*******/
		
		try {
			co.modelA = bundle
			.getString(MODEL_A);
		} catch(MissingResourceException e){
			Integer nrOfNodes = Integer.parseInt(nodes);
			co.modelA = String.valueOf(nrOfNodes/3);
		}

		try {
			co.modelB = bundle
			.getString(MODEL_B);
		} catch(MissingResourceException e){
			Integer nrOfNodes = Integer.parseInt(nodes);
			co.modelB = String.valueOf(nrOfNodes/3);
		}

		try {
			co.modelC = bundle
			.getString(MODEL_C);
		} catch(MissingResourceException e){
			Integer nrOfNodes = Integer.parseInt(nodes);
			co.modelC = String.valueOf(nrOfNodes/3);
		}

		return co;
	}

	public static String getSeparatorTerminatedPath(String path) {
		if (path.endsWith(File.separator))
			return new String(path);
		else {
			StringBuilder result = new StringBuilder(path.length()
					+ File.separator.length());
			result.append(path);
			result.append(File.separator);
			return result.toString();
		}
	}

}
